#!/bin/sh
# $Id: akpop3d-ssl.sh,v 1.2 2002/01/04 08:52:43 ak Exp $
# /etc/init.d/akpop3d-ssl: start and stop the akpop3d POP3-over-SSL daemon
# (c) 2002 Andreas Krennmair <a.krennmair@aon.at>

PIDFILE="/var/run/akpop3d-ssl.pid"
AKPOP3D="/usr/sbin/akpop3d -- -s"
SSD=start-stop-daemon

test -x /usr/sbin/akpop3d || exit 0

case "$1" in
  start)
    echo -n "Starting POP3 daemon: akpop3d"
    $SSD --start --background --quiet -m --pidfile $PIDFILE --exec $AKPOP3D &
    echo "."
    ;;
  stop)
    echo -n "Stopping POP3 daemon: akpop3d"
    $SSD --stop --quiet --oknodo --pidfile $PIDFILE
    echo "."
    ;;
  restart)
    echo -n "Restarting POP3 daemon: akpop3d"
    $SSD --stop --quiet --oknodo --pidfile $PIDFILE
    sleep 1
    $SSD --start --background --quiet -m --pidfile $PIDFILE --exec $AKPOP3D &
    sleep 1
    echo "."
    ;;
  *)
    echo "Usage /etc/init.d/akpop3d {start|stop|restart}"
    exit 1
esac

exit 0
