#include "lock_maildrop.h"
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <time.h>

int lock_maildrop(char * maildrop, uid_t uid, gid_t gid) {
  char * lf = alloca(strlen(maildrop)+strlen(".lock")+1);
  int i, fd = -1;
  struct stat s_lf;
  if (lf==NULL) {
    return 0;
  }
  strcpy(lf,maildrop);
  strcat(lf,".lock");
  fd = stat(lf,&s_lf);
  if (fd==0) {
    if (time(NULL)-s_lf.st_ctime>10*60) {
      /* stale lockfile */
      unlink(lf);
    }
  }
  for (i=0;i<5;i++) { 
    /* only create file when it doesn't exist */
    fd = open(lf,O_WRONLY|O_EXCL|O_CREAT,0600);
    if (fd < 0)
      sleep(1);
    else
      break;
  }
  if (i==5)
    return 0;
  write(fd,".",1);
  fchown(fd,uid,gid);
  close(fd);
  return 1;
}

void remove_lock(char * maildrop) {
  char * lf = alloca(strlen(maildrop)+strlen(".lock")+1);
  if (lf!=NULL) {
    strcpy(lf,maildrop);
    strcat(lf,".lock");
    unlink(lf);
  }
}

int lock_fd(int fd) {
  if (lockf(fd,F_LOCK,0)==0)
    return 1;
  return 0;
}

int unlock_fd(int fd) {
  if (lockf(fd,F_ULOCK,0)==0)
    return 1;
  return 0;
}
